# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs

__all__ = [
    'GetExternalFunctionsResult',
    'AwaitableGetExternalFunctionsResult',
    'get_external_functions',
]

@pulumi.output_type
class GetExternalFunctionsResult:
    """
    A collection of values returned by getExternalFunctions.
    """
    def __init__(__self__, database=None, external_functions=None, id=None, schema=None):
        if database and not isinstance(database, str):
            raise TypeError("Expected argument 'database' to be a str")
        pulumi.set(__self__, "database", database)
        if external_functions and not isinstance(external_functions, list):
            raise TypeError("Expected argument 'external_functions' to be a list")
        pulumi.set(__self__, "external_functions", external_functions)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if schema and not isinstance(schema, str):
            raise TypeError("Expected argument 'schema' to be a str")
        pulumi.set(__self__, "schema", schema)

    @property
    @pulumi.getter
    def database(self) -> str:
        """
        The database from which to return the schemas from.
        """
        return pulumi.get(self, "database")

    @property
    @pulumi.getter(name="externalFunctions")
    def external_functions(self) -> Sequence['outputs.GetExternalFunctionsExternalFunctionResult']:
        """
        The external functions in the schema
        """
        return pulumi.get(self, "external_functions")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def schema(self) -> str:
        """
        The schema from which to return the external functions from.
        """
        return pulumi.get(self, "schema")


class AwaitableGetExternalFunctionsResult(GetExternalFunctionsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetExternalFunctionsResult(
            database=self.database,
            external_functions=self.external_functions,
            id=self.id,
            schema=self.schema)


def get_external_functions(database: Optional[str] = None,
                           schema: Optional[str] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetExternalFunctionsResult:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_snowflake as snowflake

    current = snowflake.get_external_functions(database="MYDB",
        schema="MYSCHEMA")
    ```


    :param str database: The database from which to return the schemas from.
    :param str schema: The schema from which to return the external functions from.
    """
    __args__ = dict()
    __args__['database'] = database
    __args__['schema'] = schema
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
    __ret__ = pulumi.runtime.invoke('snowflake:index/getExternalFunctions:getExternalFunctions', __args__, opts=opts, typ=GetExternalFunctionsResult).value

    return AwaitableGetExternalFunctionsResult(
        database=__ret__.database,
        external_functions=__ret__.external_functions,
        id=__ret__.id,
        schema=__ret__.schema)
